diff --git a/sys/config/LINT64 b/sys/config/LINT64
index e2c4484f5b..d5d84e8885 100644
--- a/sys/config/LINT64
+++ b/sys/config/LINT64
@@ -408,7 +408,7 @@ options                ACCEPT_FILTER_HTTP
 # carried in TCP option 19.
 # This is enabled on a per-socket basis using the TCP_SIGNATURE_ENABLE
 # socket option.
-# This requires the use of 'device crypto' or 'device cryptodev'.
+# This requires the use of 'device crypto'
 #
 # XXX disabled for now until building with it is fixed, which broke
 # after removing IPsec.
@@ -2022,27 +2022,9 @@ options		DCONS_FORCE_GDB=1	# force to be the gdb device
 # been fed back to openbsd (and hopefully will be included).
 
 device		crypto		# core crypto support
-device		cryptodev	# /dev/crypto for access to h/w
 
 device		rndtest		# FIPS 140-2 entropy tester
 
-device		hifn		# Hifn 7951, 7781, etc.
-options		HIFN_DEBUG	# enable debugging support: hw.hifn.debug
-#options	HIFN_NO_RNG	# for devices without RNG
-options		HIFN_RNDTEST	# enable rndtest support
-
-device		safe		# SafeNet 1141
-options 	SAFE_DEBUG	# enable debugging support: hw.safe.debug
-#options	SAFE_NO_RNG	# for devices without RNG
-options 	SAFE_RNDTEST	# enable rndtest support
-
-device		ubsec		# Broadcom 5501, 5601, 58xx
-options		UBSEC_DEBUG	# enable debugging support: hw.ubsec.debug
-#options	UBSEC_NO_RNG	# for devices without RNG
-options		UBSEC_RNDTEST	# enable rndtest support
-
-device		aesni		# hardware crypto/RNG for AES-NI
-device		padlock		# hardware crypto/RNG for VIA C3/C7/Eden
 device		rdrand		# hardware RNG for RdRand
 
 #
diff --git a/sys/config/X86_64_GENERIC b/sys/config/X86_64_GENERIC
index 92c685c7df..eec377116b 100644
--- a/sys/config/X86_64_GENERIC
+++ b/sys/config/X86_64_GENERIC
@@ -297,7 +297,6 @@ pseudo-device	carp
 pseudo-device	bpf		#Berkeley packet filter
 
 device		crypto		# core crypto support, used by wlan
-device		cryptodev	# /dev/crypto for access to h/w
 
 # USB support
 #
@@ -328,8 +327,6 @@ device		sdhci
 
 # RNG
 #
-device		aesni		# hardware crypto/RNG for AES-NI
-device		padlock		# hardware crypto/RNG for VIA C3/C7/Eden
 device		rdrand		# hardware RNG for RdRand
 
 device		gpio_acpi
diff --git a/sys/crypto/Makefile b/sys/crypto/Makefile
index 95767ae474..f13d37bfc9 100644
--- a/sys/crypto/Makefile
+++ b/sys/crypto/Makefile
@@ -2,11 +2,8 @@
 
 KMOD=	crypto
 
-.PATH:	${.CURDIR}/../opencrypto
-# excluded: cryptodev.c
-SRCS=	cast.c criov.c crypto.c cryptosoft.c deflate.c gmac.c rmd160.c \
-	skipjack.c xform.c
-SRCS+=	cryptodev_if.c cryptodev_if.h
+.PATH:	${.CURDIR}
+SRCS+=	crypto_mod.c crypto_cipher.c
 
 SRCS+=	sha1.c
 SRCS+=	chachapoly.c
@@ -14,18 +11,13 @@ SRCS+=	chachapoly.c
 .PATH:	${.CURDIR}/blake2
 SRCS+=	blake2s.c
 
-.PATH:	${.CURDIR}/blowfish
-SRCS+=	bf_enc.c bf_skey.c
-
-.PATH:	${.CURDIR}/camellia
-SRCS+=	camellia.c camellia-api.c
-
 .PATH:	${.CURDIR}/chacha20
 SRCS+=	chacha.c
 
 .PATH:	${.CURDIR}/curve25519
 SRCS+=	curve25519.c
 
+# required by: smb_crypt
 .PATH:	${.CURDIR}/des
 SRCS+=	des_ecb.c des_enc.c des_setkey.c
 
@@ -35,8 +27,8 @@ SRCS+=	poly1305.c
 .PATH:	${.CURDIR}/rijndael
 SRCS+=	rijndael-alg-fst.c rijndael-api.c
 
-.PATH:	${.CURDIR}/serpent
-SRCS+=	serpent.c
+.PATH:	${.CURDIR}/rmd160
+SRCS+=	rmd160.c
 
 .PATH:	${.CURDIR}/sha2
 SRCS+=	sha2.c
@@ -44,11 +36,12 @@ SRCS+=	sha2.c
 .PATH:	${.CURDIR}/siphash
 SRCS+=	siphash.c
 
-.PATH:	${.CURDIR}/twofish
-SRCS+=	twofish.c
-
-SRCS+=	bus_if.h device_if.h opt_ddb.h
+.PATH:	${.CURDIR}/aesni
+SRCS+=	aesni.c
+SRCS+=	aesencdec_${MACHINE_ARCH}.S
+SRCS+=	aeskeys_${MACHINE_ARCH}.S
 
+# required by: netgraph
 SUBDIR=	rc4
 
 .include <bsd.kmod.mk>
diff --git a/sys/crypto/aesni/aesni.c b/sys/crypto/aesni/aesni.c
new file mode 100644
index 0000000000..17e3a0147f
--- /dev/null
+++ b/sys/crypto/aesni/aesni.c
@@ -0,0 +1,384 @@
+/*-
+ * Copyright (c) 2010 Konstantin Belousov <kib@FreeBSD.org>
+ * Copyright (c) 2010 Pawel Jakub Dawidek <pjd@FreeBSD.org>
+ * Copyright (c) 2024 Michael Neumann <mneumann@ntecs.de>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ * the documentation and/or other materials provided with the
+ * distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS''
+ * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
+ * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
+ * PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR
+ * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
+ * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
+ * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ *
+ * $FreeBSD: src/sys/crypto/aesni/aesni_wrap.c,v 1.7 2010/11/27 15:41:44
+ * kib Exp $
+ */
+
+#include <sys/param.h>
+#include <sys/systm.h>
+#include <sys/sysctl.h>
+
+#include <crypto/aesni/aesni.h>
+#include <crypto/crypto_cipher.h>
+
+static int aesni_disable = 0;
+// TUNABLE_INT("hw.aesni_disable", &aesni_disable);
+SYSCTL_INT(_hw, OID_AUTO, aesni_disable, CTLFLAG_RW, &aesni_disable, 0,
+    "Disable AESNI");
+
+/*
+ * Internal functions, implemented in assembler.
+ */
+void aesni_enc(int rounds, const uint8_t *key_schedule,
+    const uint8_t from[AES_BLOCK_LEN], uint8_t to[AES_BLOCK_LEN],
+    const uint8_t iv[AES_BLOCK_LEN]);
+void aesni_dec(int rounds, const uint8_t *key_schedule,
+    const uint8_t from[AES_BLOCK_LEN], uint8_t to[AES_BLOCK_LEN],
+    const uint8_t iv[AES_BLOCK_LEN]);
+void aesni_set_enckey(const uint8_t *userkey, uint8_t *encrypt_schedule,
+    int number_of_rounds);
+void aesni_set_deckey(const uint8_t *encrypt_schedule,
+    uint8_t *decrypt_schedule, int number_of_rounds);
+void aesni_decrypt_cbc(int rounds, const void *key_schedule, size_t len,
+    const uint8_t *from, const uint8_t iv[AES_BLOCK_LEN]);
+
+static inline void
+aesni_encrypt_cbc(int rounds, const void *key_schedule, size_t len,
+    const uint8_t *from, uint8_t *to, const uint8_t iv[AES_BLOCK_LEN])
+{
+	const uint8_t *ivp;
+	size_t i;
+
+	len /= AES_BLOCK_LEN;
+	ivp = iv;
+	for (i = 0; i < len; i++) {
+		aesni_enc(rounds - 1, key_schedule, from, to, ivp);
+		ivp = to;
+		from += AES_BLOCK_LEN;
+		to += AES_BLOCK_LEN;
+	}
+}
+
+#define AESNI_CTX(ctx) (ctx->_ctx._aesni)
+#define AESNI_IV(iv)   (iv->_iv._aesni.iv)
+
+// TODO: how to improve alignment?
+#define AESNI_ALIGNED_KEY_SCHEDULES(ctx, CONST)                     \
+	((CONST struct aesni_key_schedules                          \
+		*)((((uintptr_t)((CONST uint8_t *)&(                \
+			AESNI_CTX(ctx).key_schedules.schedules))) + \
+		       (AESNI_ALIGN - 1)) &                         \
+	    (~(AESNI_ALIGN - 1))))
+
+#define AESNI_ALIGNED_ENC_SCHEDULE(ctx, CONST) \
+	(AESNI_ALIGNED_KEY_SCHEDULES(ctx, CONST)->enc_schedule)
+
+#define AESNI_ALIGNED_DEC_SCHEDULE(ctx, CONST) \
+	(AESNI_ALIGNED_KEY_SCHEDULES(ctx, CONST)->dec_schedule)
+
+#define AESNI_ALIGNED_XTS_SCHEDULE(ctx, CONST) \
+	(AESNI_ALIGNED_KEY_SCHEDULES(ctx, CONST)->xts_schedule)
+
+#define KKASSERT_AESNI_ALIGNED(ptr) \
+	KKASSERT((((uintptr_t)(const uint8_t *)ptr) % AESNI_ALIGN) == 0)
+
+static int
+cipher_aesni_cbc_probe(const char *algo_name, const char *mode_name,
+    int keysize_in_bits)
+{
+	if (aesni_disable)
+		return (-1);
+
+	if ((cpu_feature2 & CPUID2_AESNI) == 0)
+		return (EINVAL);
+
+	if ((strcmp(algo_name, "aes") == 0) &&
+	    (strcmp(mode_name, "cbc") == 0) &&
+	    (keysize_in_bits == 128 || keysize_in_bits == 192 ||
+		keysize_in_bits == 256))
+		return (0);
+
+	return (-1);
+}
+
+static int
+cipher_aesni_cbc_setkey(struct crypto_cipher_context *ctx,
+    const uint8_t *keydata, int keylen_in_bytes)
+{
+	bzero(ctx, sizeof(*ctx));
+	int rounds;
+
+	switch (keylen_in_bytes * 8) {
+	case 128:
+		rounds = AES128_ROUNDS;
+		break;
+	case 192:
+		rounds = AES192_ROUNDS;
+		break;
+	case 256:
+		rounds = AES256_ROUNDS;
+		break;
+	default:
+		return (EINVAL);
+	}
+
+	uint8_t *enc_schedule = AESNI_ALIGNED_ENC_SCHEDULE(ctx, );
+	uint8_t *dec_schedule = AESNI_ALIGNED_DEC_SCHEDULE(ctx, );
+
+	AESNI_CTX(ctx).rounds = rounds;
+
+	aesni_set_enckey(keydata, enc_schedule, rounds);
+	aesni_set_deckey(enc_schedule, dec_schedule, rounds);
+
+	return (0);
+}
+
+static int
+cipher_aesni_cbc_encrypt(const struct crypto_cipher_context *ctx, uint8_t *data,
+    int datalen, struct crypto_cipher_iv *iv)
+{
+	if ((datalen % AES_BLOCK_LEN) != 0)
+		return (EINVAL);
+
+	const uint8_t *enc_schedule = AESNI_ALIGNED_ENC_SCHEDULE(ctx, const);
+
+	KKASSERT_AESNI_ALIGNED(enc_schedule);
+
+	aesni_encrypt_cbc(AESNI_CTX(ctx).rounds, enc_schedule, datalen, data,
+	    data, AESNI_IV(iv));
+
+	return (0);
+}
+
+static int
+cipher_aesni_cbc_decrypt(const struct crypto_cipher_context *ctx, uint8_t *data,
+    int datalen, struct crypto_cipher_iv *iv)
+{
+	if ((datalen % AES_BLOCK_LEN) != 0)
+		return (EINVAL);
+
+	const uint8_t *dec_schedule = AESNI_ALIGNED_DEC_SCHEDULE(ctx, const);
+
+	KKASSERT_AESNI_ALIGNED(dec_schedule);
+
+	aesni_decrypt_cbc(AESNI_CTX(ctx).rounds, dec_schedule, datalen, data,
+	    AESNI_IV(iv));
+
+	return (0);
+}
+
+const struct crypto_cipher cipher_aesni_cbc = {
+	"aesni-cbc",
+	"AES-CBC w/ CPU AESNI instruction",
+	AES_BLOCK_LEN,
+	AES_BLOCK_LEN,
+	sizeof(aesni_ctx),
+	cipher_aesni_cbc_probe,
+	cipher_aesni_cbc_setkey,
+	cipher_aesni_cbc_encrypt,
+	cipher_aesni_cbc_decrypt,
+};
+
+/**
+ * AES-XTS
+ */
+
+#define AES_XTS_BLOCKSIZE 16
+#define AES_XTS_IVSIZE	  8
+#define AES_XTS_ALPHA	  0x87 /* GF(2^128) generator polynomial */
+
+static void
+aesni_crypt_xts_block(int rounds, const void *key_schedule, uint8_t *tweak,
+    const uint8_t *from, uint8_t *to, int do_encrypt)
+{
+	uint8_t block[AES_XTS_BLOCKSIZE];
+	u_int i, carry_in, carry_out;
+
+	for (i = 0; i < AES_XTS_BLOCKSIZE; i++)
+		block[i] = from[i] ^ tweak[i];
+
+	if (do_encrypt)
+		aesni_enc(rounds - 1, key_schedule, block, to, NULL);
+	else
+		aesni_dec(rounds - 1, key_schedule, block, to, NULL);
+
+	for (i = 0; i < AES_XTS_BLOCKSIZE; i++)
+		to[i] ^= tweak[i];
+
+	/* Exponentiate tweak. */
+	carry_in = 0;
+	for (i = 0; i < AES_XTS_BLOCKSIZE; i++) {
+		carry_out = tweak[i] & 0x80;
+		tweak[i] = (tweak[i] << 1) | (carry_in ? 1 : 0);
+		carry_in = carry_out;
+	}
+	if (carry_in)
+		tweak[0] ^= AES_XTS_ALPHA;
+	bzero(block, sizeof(block));
+}
+
+static void
+aesni_crypt_xts(int rounds, const void *data_schedule,
+    const void *tweak_schedule, size_t len, const uint8_t *from, uint8_t *to,
+    const uint8_t iv[AES_BLOCK_LEN], int do_encrypt)
+{
+	uint8_t tweak[AES_XTS_BLOCKSIZE];
+	uint64_t blocknum;
+	size_t i;
+
+	/*
+	 * Prepare tweak as E_k2(IV). IV is specified as LE representation
+	 * of a 64-bit block number which we allow to be passed in directly.
+	 */
+	bcopy(iv, &blocknum, AES_XTS_IVSIZE);
+	for (i = 0; i < AES_XTS_IVSIZE; i++) {
+		tweak[i] = blocknum & 0xff;
+		blocknum >>= 8;
+	}
+	/* Last 64 bits of IV are always zero. */
+	bzero(tweak + AES_XTS_IVSIZE, AES_XTS_IVSIZE);
+	aesni_enc(rounds - 1, tweak_schedule, tweak, tweak, NULL);
+
+	len /= AES_XTS_BLOCKSIZE;
+	for (i = 0; i < len; i++) {
+		aesni_crypt_xts_block(rounds, data_schedule, tweak, from, to,
+		    do_encrypt);
+		from += AES_XTS_BLOCKSIZE;
+		to += AES_XTS_BLOCKSIZE;
+	}
+
+	bzero(tweak, sizeof(tweak));
+}
+
+static inline void
+aesni_encrypt_xts(int rounds, const void *data_schedule,
+    const void *tweak_schedule, size_t len, const uint8_t *from, uint8_t *to,
+    const uint8_t iv[AES_BLOCK_LEN])
+{
+	aesni_crypt_xts(rounds, data_schedule, tweak_schedule, len, from, to,
+	    iv, 1);
+}
+
+static inline void
+aesni_decrypt_xts(int rounds, const void *data_schedule,
+    const void *tweak_schedule, size_t len, const uint8_t *from, uint8_t *to,
+    const uint8_t iv[AES_BLOCK_LEN])
+{
+	aesni_crypt_xts(rounds, data_schedule, tweak_schedule, len, from, to,
+	    iv, 0);
+}
+
+static int
+cipher_aesni_xts_probe(const char *algo_name, const char *mode_name,
+    int keysize_in_bits)
+{
+	if (aesni_disable)
+		return (-1);
+
+	if ((cpu_feature2 & CPUID2_AESNI) == 0)
+		return (EINVAL);
+
+	if ((strcmp(algo_name, "aes") == 0) &&
+	    (strcmp(mode_name, "xts") == 0) &&
+	    (keysize_in_bits == 256 || keysize_in_bits == 512))
+		return (0);
+
+	return (-1);
+}
+
+static int
+cipher_aesni_xts_setkey(struct crypto_cipher_context *ctx,
+    const uint8_t *keydata, int keylen_in_bytes)
+{
+	bzero(ctx, sizeof(*ctx));
+	int rounds;
+
+	switch (keylen_in_bytes * 8) {
+	case 256:
+		rounds = AES128_ROUNDS;
+		break;
+	case 512:
+		rounds = AES256_ROUNDS;
+		break;
+	default:
+		return (EINVAL);
+	}
+
+	uint8_t *enc_schedule = AESNI_ALIGNED_ENC_SCHEDULE(ctx, );
+	uint8_t *dec_schedule = AESNI_ALIGNED_DEC_SCHEDULE(ctx, );
+	uint8_t *xts_schedule = AESNI_ALIGNED_XTS_SCHEDULE(ctx, );
+
+	AESNI_CTX(ctx).rounds = rounds;
+
+	aesni_set_enckey(keydata, enc_schedule, rounds);
+	aesni_set_deckey(enc_schedule, dec_schedule, rounds);
+	aesni_set_enckey(keydata + (keylen_in_bytes / 2), xts_schedule, rounds);
+
+	return (0);
+}
+
+static int
+cipher_aesni_xts_encrypt(const struct crypto_cipher_context *ctx, uint8_t *data,
+    int datalen, struct crypto_cipher_iv *iv)
+{
+	if ((datalen % AES_BLOCK_LEN) != 0)
+		return (EINVAL);
+
+	const uint8_t *enc_schedule = AESNI_ALIGNED_ENC_SCHEDULE(ctx, const);
+	const uint8_t *xts_schedule = AESNI_ALIGNED_XTS_SCHEDULE(ctx, const);
+
+	KKASSERT_AESNI_ALIGNED(enc_schedule);
+	KKASSERT_AESNI_ALIGNED(xts_schedule);
+
+	aesni_encrypt_xts(AESNI_CTX(ctx).rounds, enc_schedule, xts_schedule,
+	    datalen, data, data, AESNI_IV(iv));
+
+	return (0);
+}
+
+static int
+cipher_aesni_xts_decrypt(const struct crypto_cipher_context *ctx, uint8_t *data,
+    int datalen, struct crypto_cipher_iv *iv)
+{
+	if ((datalen % AES_BLOCK_LEN) != 0)
+		return (EINVAL);
+
+	const uint8_t *dec_schedule = AESNI_ALIGNED_DEC_SCHEDULE(ctx, const);
+	const uint8_t *xts_schedule = AESNI_ALIGNED_XTS_SCHEDULE(ctx, const);
+
+	KKASSERT_AESNI_ALIGNED(dec_schedule);
+	KKASSERT_AESNI_ALIGNED(xts_schedule);
+
+	aesni_decrypt_xts(AESNI_CTX(ctx).rounds, dec_schedule, xts_schedule,
+	    datalen, data, data, AESNI_IV(iv));
+
+	return (0);
+}
+
+const struct crypto_cipher cipher_aesni_xts = {
+	"aesni-xts",
+	"AES-XTS w/ CPU AESNI instruction",
+	AES_BLOCK_LEN,
+	AES_BLOCK_LEN,
+	sizeof(aesni_ctx),
+	cipher_aesni_xts_probe,
+	cipher_aesni_xts_setkey,
+	cipher_aesni_xts_encrypt,
+	cipher_aesni_xts_decrypt,
+};
diff --git a/sys/crypto/aesni/aesni.h b/sys/crypto/aesni/aesni.h
new file mode 100644
index 0000000000..d915e05700
--- /dev/null
+++ b/sys/crypto/aesni/aesni.h
@@ -0,0 +1,71 @@
+/*-
+ * Copyright (c) 2010 Konstantin Belousov <kib@FreeBSD.org>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD: src/sys/crypto/aesni/aesni.h,v 1.2 2010/09/23 11:57:25 pjd Exp $
+ */
+
+#ifndef _AESNI_H_
+#define _AESNI_H_
+
+#if defined(__x86_64__)
+#include <machine/cpufunc.h>
+#include <machine/cputypes.h>
+#include <machine/md_var.h>
+#include <machine/specialreg.h>
+#endif
+
+#define AES_BLOCK_LEN 16
+
+#define AESNI_ALIGN   16
+
+#define AES128_ROUNDS 10
+#define AES192_ROUNDS 12
+#define AES256_ROUNDS 14
+#define AES_SCHED_LEN ((AES256_ROUNDS + 1) * AES_BLOCK_LEN)
+
+typedef struct {
+	uint8_t iv[AES_BLOCK_LEN];
+} aesni_iv;
+
+struct aesni_key_schedules {
+	uint8_t enc_schedule[AES_SCHED_LEN] __aligned(16);
+	uint8_t dec_schedule[AES_SCHED_LEN] __aligned(16);
+	uint8_t xts_schedule[AES_SCHED_LEN] __aligned(16);
+};
+
+struct aesni_key_schedules_padded {
+	struct aesni_key_schedules schedules;
+	uint8_t _padding[AESNI_ALIGN];
+};
+
+typedef struct {
+	struct aesni_key_schedules_padded key_schedules;
+	int rounds;
+} aesni_ctx;
+
+extern const struct crypto_cipher cipher_aesni_cbc;
+extern const struct crypto_cipher cipher_aesni_xts;
+
+#endif
diff --git a/sys/crypto/crypto_cipher.c b/sys/crypto/crypto_cipher.c
new file mode 100644
index 0000000000..d75f8a5f06
--- /dev/null
+++ b/sys/crypto/crypto_cipher.c
@@ -0,0 +1,389 @@
+/*-
+ * The authors of this code are John Ioannidis (ji@tla.org),
+ * Angelos D. Keromytis (kermit@csd.uch.gr) and
+ * Niels Provos (provos@physnet.uni-hamburg.de).
+ *
+ * This code was written by John Ioannidis for BSD/OS in Athens, Greece,
+ * in November 1995.
+ *
+ * Ported to OpenBSD and NetBSD, with additional transforms, in December
+ * 1996, by Angelos D. Keromytis.
+ *
+ * Additional transforms and features in 1997 and 1998 by Angelos D.
+ * Keromytis and Niels Provos.
+ *
+ * Additional features in 1999 by Angelos D. Keromytis.
+ *
+ * Copyright (C) 1995, 1996, 1997, 1998, 1999 by John Ioannidis,
+ * Angelos D. Keromytis and Niels Provos.
+ *
+ * Copyright (C) 2001, Angelos D. Keromytis.
+ *
+ * Copyright (c) 2024, Michael Neumann.
+ *
+ * Permission to use, copy, and modify this software with or without fee
+ * is hereby granted, provided that this entire notice is included in
+ * all copies of any software which is or includes a copy or
+ * modification of this software.
+ * You may use this code under the GNU public license if you so wish.
+ * Please contribute changes back to the authors under this freer than
+ * GPL license so that we may further the use of strong encryption
+ * without limitations to all.
+ *
+ * THIS SOFTWARE IS BEING PROVIDED "AS IS", WITHOUT ANY EXPRESS OR
+ * IMPLIED WARRANTY. IN PARTICULAR, NONE OF THE AUTHORS MAKES ANY
+ * REPRESENTATION OR WARRANTY OF ANY KIND CONCERNING THE
+ * MERCHANTABILITY OF THIS SOFTWARE OR ITS FITNESS FOR ANY PARTICULAR
+ * PURPOSE.
+ */
+
+#include <sys/types.h>
+#include <sys/param.h>
+#include <sys/systm.h>
+
+#include <crypto/crypto_cipher.h>
+
+/**
+ * --------------------------------------
+ *  Utility
+ * --------------------------------------
+ */
+
+static inline void
+xor_block(uint8_t *dst, const uint8_t *src, int blocksize)
+{
+	for (int i = 0; i < blocksize; i++)
+		dst[i] ^= src[i];
+}
+
+typedef void (*block_fn_t)(const void *ctx, uint8_t *data, uint8_t *data2);
+
+/*
+ * XOR with the IV/previous block, as appropriate.
+ */
+#define ENCRYPT_DATA_CBC(block_fn, ctx, data, datalen, blocksize, iv)       \
+	for (int i = 0; i < datalen; i += blocksize) {                      \
+		xor_block(data + i, (i == 0) ? iv : (data + i - blocksize), \
+		    blocksize);                                             \
+		block_fn(ctx, data + i, data + i);                          \
+	}
+
+/*
+ * Start at the end, so we don't need to keep the
+ * encrypted block as the IV for the next block.
+ *
+ * XOR with the IV/previous block, as appropriate
+ */
+#define DECRYPT_DATA_CBC(block_fn, ctx, data, datalen, blocksize, iv)       \
+	for (int i = datalen - blocksize; i >= 0; i -= blocksize) {         \
+		block_fn(ctx, data + i, data + i);                          \
+		xor_block(data + i, (i == 0) ? iv : (data + i - blocksize), \
+		    blocksize);                                             \
+	}
+
+/**
+ * --------------------------------------
+ * Cipher null
+ * --------------------------------------
+ */
+
+static int
+cipher_null_probe(const char *algo_name, const char *mode_name __unused,
+    int keysize_in_bits __unused)
+{
+	if (strcmp(algo_name, "null") == 0)
+		return (0);
+	return (-1);
+}
+
+static int
+cipher_null_setkey(struct crypto_cipher_context *ctx __unused,
+    const uint8_t *keydata __unused, int keylen_in_bytes __unused)
+{
+	return (0);
+}
+
+static int
+cipher_null_encrypt(const struct crypto_cipher_context *ctx __unused,
+    uint8_t *data __unused, int datalen __unused,
+    struct crypto_cipher_iv *iv __unused)
+{
+	return (0);
+}
+
+static int
+cipher_null_decrypt(const struct crypto_cipher_context *ctx __unused,
+    uint8_t *data, int datalen, struct crypto_cipher_iv *iv __unused)
+{
+	return (0);
+}
+
+const struct crypto_cipher cipher_null = {
+	"null",
+	"null",
+	4,
+	0,
+	0,
+	cipher_null_probe,
+	cipher_null_setkey,
+	cipher_null_encrypt,
+	cipher_null_decrypt,
+};
+
+/**
+ * --------------------------------------
+ * AES-CBC (Rijndael-128)
+ * --------------------------------------
+ */
+
+#define AES_BLOCK_LEN 16
+
+static int
+aes_cbc_probe(const char *algo_name, const char *mode_name, int keysize_in_bits)
+{
+	if ((strcmp(algo_name, "aes") == 0) &&
+	    (strcmp(mode_name, "cbc") == 0) &&
+	    (keysize_in_bits == 128 || keysize_in_bits == 192 ||
+		keysize_in_bits == 256))
+		return (0);
+	else
+		return (-1);
+}
+
+static int
+aes_cbc_setkey(struct crypto_cipher_context *ctx, const uint8_t *keydata,
+    int keylen_in_bytes)
+{
+	switch (keylen_in_bytes * 8) {
+	case 128:
+	case 192:
+	case 256:
+		rijndael_set_key((void *)ctx, keydata, keylen_in_bytes * 8);
+		return (0);
+
+	default:
+		return (EINVAL);
+	}
+}
+
+static int
+aes_cbc_encrypt(const struct crypto_cipher_context *ctx, uint8_t *data,
+    int datalen, struct crypto_cipher_iv *iv)
+{
+	if ((datalen % AES_BLOCK_LEN) != 0)
+		return EINVAL;
+
+	ENCRYPT_DATA_CBC(rijndael_encrypt, (const void *)ctx, data, datalen,
+	    AES_BLOCK_LEN, (uint8_t *)iv);
+
+	return (0);
+}
+
+static int
+aes_cbc_decrypt(const struct crypto_cipher_context *ctx, uint8_t *data,
+    int datalen, struct crypto_cipher_iv *iv)
+{
+	if ((datalen % AES_BLOCK_LEN) != 0)
+		return EINVAL;
+
+	DECRYPT_DATA_CBC(rijndael_decrypt, (const void *)ctx, data, datalen,
+	    AES_BLOCK_LEN, (uint8_t *)iv);
+
+	return (0);
+}
+
+const struct crypto_cipher cipher_aes_cbc = {
+	"aes-cbc",
+	"AES-CBC (Rijndael-128) in software",
+	AES_BLOCK_LEN,
+	AES_BLOCK_LEN,
+	sizeof(rijndael_ctx),
+	aes_cbc_probe,
+	aes_cbc_setkey,
+	aes_cbc_encrypt,
+	aes_cbc_decrypt,
+};
+
+/**
+ * --------------------------------------
+ * AES-XTS
+ * --------------------------------------
+ */
+
+#define AES_XTS_BLOCK_LEN 16
+#define AES_XTS_IV_LEN	  8
+#define AES_XTS_ALPHA	  0x87 /* GF(2^128) generator polynomial */
+
+static void
+aes_xts_crypt_block(const struct aes_xts_ctx *ctx, uint8_t *data, uint8_t *iv,
+    bool do_encrypt)
+{
+	uint8_t block[AES_XTS_BLOCK_LEN];
+	u_int i, carry_in, carry_out;
+
+	for (i = 0; i < AES_XTS_BLOCK_LEN; i++)
+		block[i] = data[i] ^ iv[i];
+
+	if (do_encrypt)
+		rijndael_encrypt(&ctx->key1, block, data);
+	else
+		rijndael_decrypt(&ctx->key1, block, data);
+
+	for (i = 0; i < AES_XTS_BLOCK_LEN; i++)
+		data[i] ^= iv[i];
+
+	/* Exponentiate tweak */
+	carry_in = 0;
+	for (i = 0; i < AES_XTS_BLOCK_LEN; i++) {
+		carry_out = iv[i] & 0x80;
+		iv[i] = (iv[i] << 1) | (carry_in ? 1 : 0);
+		carry_in = carry_out;
+	}
+	if (carry_in)
+		iv[0] ^= AES_XTS_ALPHA;
+	explicit_bzero(block, sizeof(block));
+}
+
+static bool
+aes_xts_valid_keysize_in_bits(int keysize_in_bits)
+{
+	switch (keysize_in_bits) {
+	case 256:
+	case 512:
+		return true;
+	default:
+		return false;
+	}
+}
+
+static int
+aes_xts_probe(const char *algo_name, const char *mode_name, int keysize_in_bits)
+{
+	if (strcmp(algo_name, "aes") != 0)
+		return (-1);
+
+	if (strcmp(mode_name, "xts") != 0)
+		return (-1);
+
+	if (aes_xts_valid_keysize_in_bits(keysize_in_bits))
+		return (0);
+
+	return (-1);
+}
+
+static int
+aes_xts_setkey(struct crypto_cipher_context *ctx, const uint8_t *keydata,
+    int keylen_in_bytes)
+{
+	if (!aes_xts_valid_keysize_in_bits(keylen_in_bytes * 8))
+		return (EINVAL);
+
+	rijndael_set_key(&ctx->_ctx._aes_xts.key1, keydata,
+	    (keylen_in_bytes / 2) * 8);
+	rijndael_set_key(&ctx->_ctx._aes_xts.key2,
+	    keydata + (keylen_in_bytes / 2), (keylen_in_bytes / 2) * 8);
+
+	return (0);
+}
+
+static void
+aes_xts_reinit(const struct aes_xts_ctx *ctx, u_int8_t *iv)
+{
+#if 0
+	/*
+	 * Prepare tweak as E_k2(IV). IV is specified as LE representation
+	 * of a 64-bit block number which we allow to be passed in directly.
+	 */
+	/* XXX: possibly use htole64? */
+#endif
+	/* Last 64 bits of IV are always zero */
+	bzero(iv + AES_XTS_IV_LEN, AES_XTS_IV_LEN);
+
+	rijndael_encrypt(&ctx->key2, iv, iv);
+}
+
+static int
+aes_xts_encrypt(const struct crypto_cipher_context *_ctx, uint8_t *data,
+    int datalen, struct crypto_cipher_iv *_iv)
+{
+	uint8_t *iv = _iv->_iv._aes_xts;
+	const struct aes_xts_ctx *ctx = &_ctx->_ctx._aes_xts;
+
+	if ((datalen % AES_XTS_BLOCK_LEN) != 0)
+		return EINVAL;
+
+	aes_xts_reinit(ctx, iv);
+	for (int i = 0; i < datalen; i += AES_XTS_BLOCK_LEN) {
+		aes_xts_crypt_block(ctx, data + i, iv, true);
+	}
+
+	return (0);
+}
+
+static int
+aes_xts_decrypt(const struct crypto_cipher_context *_ctx, uint8_t *data,
+    int datalen, struct crypto_cipher_iv *_iv)
+{
+	uint8_t *iv = _iv->_iv._aes_xts;
+	const struct aes_xts_ctx *ctx = &_ctx->_ctx._aes_xts;
+
+	if ((datalen % AES_XTS_BLOCK_LEN) != 0)
+		return EINVAL;
+
+	aes_xts_reinit(ctx, iv);
+	for (int i = 0; i < datalen; i += AES_XTS_BLOCK_LEN) {
+		aes_xts_crypt_block(ctx, data + i, iv, false);
+	}
+
+	return (0);
+}
+
+const struct crypto_cipher cipher_aes_xts = {
+	"aes-xts",
+	"AES-XTS (in software)",
+	AES_XTS_BLOCK_LEN,
+	16,
+	sizeof(struct aes_xts_ctx),
+	aes_xts_probe,
+	aes_xts_setkey,
+	aes_xts_encrypt,
+	aes_xts_decrypt,
+};
+
+/**
+ *
+ */
+
+const struct crypto_cipher *crypto_ciphers[6] = {
+
+	&cipher_null,
+
+	/* first probe AESNI, then fallback to software AES */
+	&cipher_aesni_cbc, &cipher_aesni_xts,
+
+	/* AES in software */
+	&cipher_aes_cbc, &cipher_aes_xts,
+
+	NULL
+};
+
+/**
+ * --------------------------------------
+ * --------------------------------------
+ */
+
+const struct crypto_cipher *
+crypto_cipher_find(const char *algo_name, const char *mode_name,
+    int keysize_in_bits)
+{
+	for (const struct crypto_cipher **cipherpp = crypto_ciphers; *cipherpp;
+	     ++cipherpp) {
+		const struct crypto_cipher *cipherp = *cipherpp;
+		if ((*cipherp->probe)(algo_name, mode_name, keysize_in_bits) ==
+		    0) {
+			return cipherp;
+		}
+	}
+
+	return NULL;
+}
diff --git a/sys/crypto/crypto_cipher.h b/sys/crypto/crypto_cipher.h
new file mode 100644
index 0000000000..0470b972f7
--- /dev/null
+++ b/sys/crypto/crypto_cipher.h
@@ -0,0 +1,54 @@
+#ifndef _CRYPTO_CIPHER_H_
+#define _CRYPTO_CIPHER_H_
+
+#include <crypto/aesni/aesni.h>
+#include <crypto/rijndael/rijndael.h>
+
+struct aes_xts_ctx {
+	rijndael_ctx key1;
+	rijndael_ctx key2;
+};
+
+struct crypto_cipher_context {
+	union {
+		rijndael_ctx _rijndael;
+		aesni_ctx _aesni;
+		struct aes_xts_ctx _aes_xts;
+	} _ctx;
+};
+
+struct crypto_cipher_iv {
+	union {
+		uint8_t _rijndael[16];
+		aesni_iv _aesni;
+		uint8_t _aes_xts[16]; /* 16 bytes are used, but the last 8 bytes
+					 are zero */
+	} _iv;
+};
+
+typedef int (*crypto_cipher_blockfn_t)(const struct crypto_cipher_context *ctx,
+    uint8_t *data, int datalen, struct crypto_cipher_iv *iv);
+
+typedef int (*crypto_cipher_probe_t)(const char *algo_name,
+    const char *mode_name, int keysize_in_bits);
+
+typedef int (*crypto_cipher_setkey_t)(struct crypto_cipher_context *ctx,
+    const uint8_t *keydata, int keylen_in_bytes);
+
+struct crypto_cipher {
+	const char *shortname;
+	const char *description;
+	uint16_t blocksize;
+	uint16_t ivsize;
+	uint16_t ctxsize;
+
+	crypto_cipher_probe_t probe;
+	crypto_cipher_setkey_t setkey;
+	crypto_cipher_blockfn_t encrypt;
+	crypto_cipher_blockfn_t decrypt;
+};
+
+const struct crypto_cipher *crypto_cipher_find(const char *algo_name,
+    const char *mode_name, int keysize_in_bits);
+
+#endif
diff --git a/sys/crypto/crypto_mod.c b/sys/crypto/crypto_mod.c
new file mode 100644
index 0000000000..bd04980c47
--- /dev/null
+++ b/sys/crypto/crypto_mod.c
@@ -0,0 +1,42 @@
+/*
+ * Copyright (c) 2024 Michael Neumann <mneumann@ntecs.de>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the
+ * above copyright notice and this permission notice appear in all
+ * copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
+ * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
+ * AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
+ * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
+ * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
+ * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
+ * PERFORMANCE OF THIS SOFTWARE.
+ */
+
+/*
+ * Crypto module stub for dynamic and static linking.
+ *
+ * The OpenBSD Crypto Framework (OCF) is gone. This is a much simpler
+ * approach.
+ */
+
+#include <sys/module.h>
+
+int crypto_modevent(module_t mod, int type, void *unused);
+
+int
+crypto_modevent(module_t mod, int type, void *unused)
+{
+	switch (type) {
+	case MOD_LOAD:
+		break;
+	case MOD_UNLOAD:
+		break;
+	}
+	return (0);
+}
+
+MODULE_VERSION(crypto, 2);
diff --git a/sys/opencrypto/rmd160.c b/sys/crypto/rmd160/rmd160.c
similarity index 99%
rename from sys/opencrypto/rmd160.c
rename to sys/crypto/rmd160/rmd160.c
index 420723d209..cc8191bd4b 100644
--- a/sys/opencrypto/rmd160.c
+++ b/sys/crypto/rmd160/rmd160.c
@@ -33,7 +33,7 @@
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/endian.h>
-#include <opencrypto/rmd160.h>
+#include <crypto/rmd160/rmd160.h>
 
 #define PUT_64BIT_LE(cp, value) do { \
 	(cp)[7] = (value) >> 56; \
diff --git a/sys/dev/crypto/Makefile b/sys/dev/crypto/Makefile
index ad042d8baa..e6a6d452a8 100644
--- a/sys/dev/crypto/Makefile
+++ b/sys/dev/crypto/Makefile
@@ -1,4 +1,4 @@
-SUBDIR=	aesni cryptodev hifn padlock rdrand rndtest safe tpm ubsec
+SUBDIR=	rdrand rndtest tpm
 
 # Empty for concurrent build
 #
diff --git a/sys/dev/disk/dm/crypt/Makefile b/sys/dev/disk/dm/crypt/Makefile
index a8a241bdf8..0454bc7bce 100644
--- a/sys/dev/disk/dm/crypt/Makefile
+++ b/sys/dev/disk/dm/crypt/Makefile
@@ -1,6 +1,6 @@
 KMOD=   dm_target_crypt
 
-SRCS+=	bus_if.h device_if.h opt_ktr.h
-SRCS+=	dm_target_crypt.c
+SRCS+=	bus_if.h device_if.h
+SRCS+=	dm_target_crypt.c ../../../../crypto/crypto_cipher.h
 
 .include <bsd.kmod.mk>
